﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace GrowthControl
{
    class Button
    {
        Rectangle size;
        string label;
        bool prepressed;

        public Button(Vector2 position, string setLabel)
        {
            label = setLabel;
            size = new Rectangle((int)(position.X - GameInterface.menuFont.MeasureString(label).X * 0.5), (int)(position.Y - GameInterface.menuFont.MeasureString(label).Y * 0.5), (int)GameInterface.menuFont.MeasureString(label).X, (int)GameInterface.menuFont.MeasureString(label).Y);
        }

        public bool MouseHover()
        {
            return InputController.MousePosition.X > size.Left && InputController.MousePosition.X < size.Right && InputController.MousePosition.Y > size.Top && InputController.MousePosition.Y < size.Bottom;
        }

        public bool IsPressed()
        {
            if (InputController.LeftPress() && MouseHover()) prepressed = true;
            return InputController.LeftRelease() && MouseHover() && prepressed;
        }

        public void Draw()
        {
            if (MouseHover())
            {
                GameServices.spriteBatch.DrawString(GameInterface.menuFont, label, new Vector2(size.X, size.Y), new Color(1f, 1f, 1f));
            }
            else
            {
                GameServices.spriteBatch.DrawString(GameInterface.menuFont, label, new Vector2(size.X, size.Y), new Color(0.8f, 0.8f, 0.8f));
            }
        }
    }
}
