﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace GrowthControl
{
    class GameEnd
    {
        Sprite background;
        Button buttonAgain;
        Button buttonExit;

        bool greenWins;

        public GameEnd(bool setGreenWins)
        {
            greenWins = setGreenWins;
            background = new Sprite(GameServices.content);
            background.ChangeContent("Background");
            background.Position = new Vector2(960, 600);

            buttonAgain = new Button(new Vector2(960, 650), "Play again");
            buttonExit = new Button(new Vector2(960, 750), "Exit to main menu");
        }

        public void Update()
        {
            if (buttonAgain.IsPressed()) GameInterface.world.StartGame(GameInterface.world.multiplayer, GameInterface.world.hardmode);
            if (buttonExit.IsPressed()) GameInterface.inGame = false;
        }

        public void Draw()
        {
            background.Draw(new Vector2(0.4f, 0.5f));

            string text = "CYAN WINS";
            if (!greenWins) {
                text = "RED WINS";
            }
            Vector2 textPosition = new Vector2(960 - GameInterface.titleFont.MeasureString(text).X * 0.5f, 400);
            GameServices.spriteBatch.DrawString(GameInterface.titleFont, text, textPosition, new Color(1f, 1f, 1f));

            text = "In " + GameInterface.world.turns + " turns";
            textPosition = new Vector2(960 - GameInterface.smallFont.MeasureString(text).X * 0.5f, 530);
            GameServices.spriteBatch.DrawString(GameInterface.smallFont, text, textPosition, new Color(1f, 1f, 1f));

            buttonAgain.Draw();
            buttonExit.Draw();
        }
    }
}
