﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;

namespace GrowthControl
{
    static class GameInterface
    {
        public static GameWorld world;
        public static MainMenu mainMenu;
        public static SpriteFont menuFont;
        public static SpriteFont titleFont;
        public static SpriteFont smallFont;
        public static bool inGame;
        public static Game1 game;

        public static void Init()
        {
            menuFont = GameServices.content.Load<SpriteFont>("MenuFont");
            titleFont = GameServices.content.Load<SpriteFont>("TitleFont");
            smallFont = GameServices.content.Load<SpriteFont>("SmallFont");
            mainMenu = new MainMenu();
            world = new GameWorld();
            //world.StartGame();
        }

        public static void Update()
        {
            if (inGame)
            {
                world.Update();
            }
            else
            {
                mainMenu.Update();
            }
        }

        public static void Draw()
        {
            if (inGame)
            {
                world.Draw();
            }
            else
            {
                mainMenu.Draw();
            }
        }
    }
}
