﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;

namespace GrowthControl
{
    static class InputController
    {
        static KeyboardState previousKeyboardState;
        static MouseState previousMouseState;
        static KeyboardState keyboardState;
        static MouseState mouseState;

        public static void Init()
        {
            previousKeyboardState = keyboardState = Keyboard.GetState();
            previousMouseState = mouseState = Mouse.GetState();
        }

        public static void Update()
        {
            previousKeyboardState = keyboardState;
            previousMouseState = mouseState;
            keyboardState = Keyboard.GetState();
            mouseState = Mouse.GetState();
        }

        public static Vector2 MousePosition
        {
            get
            {
                return new Vector2(mouseState.X, mouseState.Y) / (GameServices.resolution.Y / 1080);
            }
        }

        public static bool LeftPress()
        {
            return mouseState.LeftButton == ButtonState.Pressed && previousMouseState.LeftButton == ButtonState.Released;
        }

        public static bool LeftRelease()
        {
            return mouseState.LeftButton == ButtonState.Released && previousMouseState.LeftButton == ButtonState.Pressed;
        }

        public static bool RightPress()
        {
            return mouseState.RightButton == ButtonState.Pressed && previousMouseState.RightButton == ButtonState.Released;
        }

        public static bool RightRelease()
        {
            return mouseState.RightButton == ButtonState.Released && previousMouseState.RightButton == ButtonState.Pressed;
        }

        public static bool KeyReleased(Keys key)
        {
            return keyboardState.IsKeyUp(key) && previousKeyboardState.IsKeyDown(key);
        }
    }
}
