﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace GrowthControl
{
    class MainMenu
    {
        Button buttonSolo;
        Button buttonSoloHard;
        Button buttonMulti;
        Button buttonInstructions;
        Button buttonExit;
        Sprite background;
        public bool instructionsShown;
        Instructions instructionsMenu;

        public MainMenu()
        {
            buttonSolo = new Button(new Vector2(960, 450), "1 Player Easy");
            buttonSoloHard = new Button(new Vector2(960, 550), "1 Player Hard");
            buttonMulti = new Button(new Vector2(960, 650), "2 Players");
            buttonInstructions = new Button(new Vector2(960, 750), "How to Play");
            buttonExit = new Button(new Vector2(960, 950), "Exit");
            background = new Sprite(GameServices.content);
            background.ChangeContent("Background");
            background.Position = new Vector2(960, 540);

            instructionsMenu = new Instructions();
        }

        public void Update()
        {
            if (instructionsShown)
            {
                instructionsMenu.Update();
            }
            else
            {
                if (buttonSolo.IsPressed()) GameInterface.world.StartGame(false, false);
                if (buttonSoloHard.IsPressed()) GameInterface.world.StartGame(false, true);
                if (buttonMulti.IsPressed()) GameInterface.world.StartGame(true, false);
                if (buttonInstructions.IsPressed()) instructionsShown = true;
                if (buttonExit.IsPressed()) GameInterface.game.Exit();
            }
        }

        public void Draw()
        {
            Matrix translation = Matrix.CreateScale(GameServices.resolution.Y / 1080);
            GameServices.spriteBatch.Begin(SpriteSortMode.Immediate, BlendState.Additive, SamplerState.LinearClamp, DepthStencilState.Default, RasterizerState.CullCounterClockwise, null, translation);
            background.Draw();

            if (instructionsShown)
            {
                instructionsMenu.Draw();
            }
            else
            {
                string text = "GROWTH CONTROL";
                Vector2 textPosition = new Vector2(960 - GameInterface.titleFont.MeasureString(text).X * 0.5f, 100);
                GameServices.spriteBatch.DrawString(GameInterface.titleFont, text, textPosition, new Color(1f, 1f, 1f));

                GameServices.spriteBatch.DrawString(GameInterface.smallFont, "Created by Sandra Lenardova\nfor Ludum Dare 34\nwww.purplenebulagames.com", new Vector2(30, 970), new Color(0.7f, 0.7f, 0.7f));

                buttonSolo.Draw();
                buttonSoloHard.Draw();
                buttonMulti.Draw();
                buttonInstructions.Draw();
                buttonExit.Draw();
            }
            GameServices.spriteBatch.End();
        }
    }
}
