﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace GrowthControl
{
    class NodeAttack : Node
    {
        public NodeAttack()
        {
            connections = new List<Connection>();
            graphics = new Sprite(GameServices.content);
            graphics.ChangeContent("Symbols");
            graphics.Source = new Rectangle(55, 0, 50, 50);

            outline = new Sprite(GameServices.content);
            outline.ChangeContent("Symbols");
            outline.Source = new Rectangle(330, 0, 50, 50);

            selection = new Sprite(GameServices.content);
            selection.ChangeContent("Symbols");
            selection.Source = new Rectangle(322, 53, 58, 58);
        }

        public void RotateTo(Vector2 target)
        {
            graphics.Rotation = (float)Math.Atan2(target.Y - position.Y, target.X - position.X) + (float)(Math.PI * 0.5);
        }

        public override void Update()
        {
            base.Update();
            if (GameInterface.inGame)
            {
                if (Selected && InputController.RightRelease() && GameInterface.world.currentPlayer == owner && !moveMode)
                {
                    bool otherNodeHover = false;
                    foreach (Node node in GameInterface.world.Nodes)
                    {
                        if (node.MouseHover)
                        {
                            otherNodeHover = true;
                            break;
                        }
                    }
                    if (!otherNodeHover && !used)
                    {
                        GameInterface.world.Attack(this, InputController.MousePosition);
                    }
                }


                if (Selected && !moveMode && !used)
                {
                    RotateTo(InputController.MousePosition);
                }
            }
        }
    }
}
