﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace GrowthControl
{
    class NodeHome : Node
    {
        public int freeSupplies;
        List<Sprite> supplyGraphics;
        public NodeHome()
        {
            connections = new List<Connection>();
            unmovable = true;
            graphics = new Sprite(GameServices.content);
            graphics.ChangeContent("Symbols");
            graphics.Source = new Rectangle(220, 0, 50, 50);

            outline = new Sprite(GameServices.content);
            outline.ChangeContent("Symbols");
            outline.Source = new Rectangle(330, 0, 50, 50);

            selection = new Sprite(GameServices.content);
            selection.ChangeContent("Symbols");
            selection.Source = new Rectangle(322, 53, 58, 58);

            supplyGraphics = new List<Sprite>();
            for (int i = 0; i < 5; i++)
            {
                Sprite supply = new Sprite(GameServices.content);
                supply.ChangeContent("Symbols");
                supply.Source = new Rectangle(275, 0, 50, 50);
                supply.Rotation = i * (float)(Math.PI * 0.4);
                supplyGraphics.Add(supply);
            }
        }

        public override void Update()
        {
            base.Update(); 
            foreach (Sprite supply in supplyGraphics)
            {
                supply.Position = position;
            }

            if (GameInterface.inGame && Selected && MouseHover && InputController.RightRelease() && GameInterface.world.currentPlayer == owner)
            {
                GameInterface.world.EndTurn();
            }
        }

        public override void Draw()
        {
            base.Draw();
            used = GameInterface.world.currentPlayer != owner;

            for (int i = 0; i < 5; i++)
            {
                if (owner == null)
                {
                    supplyGraphics[i].Draw(new Color(127, 127, 127));
                }
                else if (i < freeSupplies)
                {
                    supplyGraphics[i].Draw(owner.PlayerColor);
                }
                else
                {
                    Color color = owner.PlayerColor * 0.4f;
                    color.A = 255;
                    supplyGraphics[i].Draw(color);
                }
            }
        }
    }
}
