﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace GrowthControl
{
    class NodeSupply : Node
    {
        public int freeSupplies;
        List<Sprite> supplyGraphics;

        public NodeSupply()
        {
            connections = new List<Connection>();
            graphics = new Sprite(GameServices.content);
            graphics.ChangeContent("Symbols");
            graphics.Source = new Rectangle(0, 0, 1, 1);

            outline = new Sprite(GameServices.content);
            outline.ChangeContent("Symbols");
            outline.Source = new Rectangle(330, 0, 50, 50);

            selection = new Sprite(GameServices.content);
            selection.ChangeContent("Symbols");
            selection.Source = new Rectangle(322, 53, 58, 58);

            supplyGraphics = new List<Sprite>();
            for (int i = 0; i < 4; i++)
            {
                Sprite supply = new Sprite(GameServices.content);
                supply.ChangeContent("Symbols");
                supply.Source = new Rectangle(0, 0, 50, 50);
                supply.Rotation = i * (float)(Math.PI * 0.5);
                supplyGraphics.Add(supply);
            }

        }

        public override void Update()
        {
            base.Update();
            foreach (Sprite supply in supplyGraphics)
            {
                supply.Position = position;
            }
        }

        public override void Draw()
        {
            base.Draw();

            for (int i = 0; i < 4; i++)
            {
                if (owner == null)
                {
                    supplyGraphics[i].Draw(new Color(127, 127, 127));
                }
                else if (i < freeSupplies)
                {
                    supplyGraphics[i].Draw(owner.PlayerColor);
                }
                else
                {
                    Color color = owner.PlayerColor * 0.4f;
                    color.A = 255;
                    supplyGraphics[i].Draw(color);
                }
            }
        }
    }
}
