﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace GrowthControl
{
    class Particle
    {
        Vector2 position;
        Vector2 velocity;
        Color color;
        Sprite graphics;
        Spit parent;

        public Particle(Vector2 setPosition, Vector2 setVelocity, Color setColor, Spit setParent)
        {
            position = setPosition;
            velocity = setVelocity;
            color = setColor;
            parent = setParent;
            graphics = new Sprite(GameServices.content);
            graphics.ChangeContent("Symbols");
            graphics.Source = new Rectangle(210, 60, 20, 20);
            graphics.Scale = 1;
        }

        public void Update()
        {
            position += velocity * (float)GameServices.time.ElapsedGameTime.TotalSeconds;
            velocity *= 0.9f;
            graphics.Position = position;
            graphics.Scale -= 0.01f;
            color *= 0.99f;
        }

        public void Draw()
        {
            if (graphics.Scale > 0)
            {
                graphics.Draw(color);
            } 
            else
            {
                parent.RemoveParticle(this);
            }
        }
    }
}
